// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GTKMM_SIZEREQUEST_H
#define _GTKMM_SIZEREQUEST_H


#include <glibmm.h>

/* $Id: sizerequest.hg,v 1.3 2006/05/18 17:53:15 murrayc Exp $ */

/* Copyright (C) 2010 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <glibmm/interface.h>
#include <gtkmm/enums.h>
#include <gtk/gtk.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GtkSizeRequest GtkSizeRequest;
typedef struct _GtkSizeRequestClass GtkSizeRequestClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gtk
{ class SizeRequest_Class; } // namespace Gtk
namespace Gtk
{

//TODO: Documentation.
typedef GtkRequisition Requisition;

/** @addtogroup gtkmmEnums gtkmm Enums and Flags */

/**
 * @ingroup gtkmmEnums
 */
enum SizeRequestMode
{
  SIZE_REQUEST_HEIGHT_FOR_WIDTH,
  SIZE_REQUEST_WIDTH_FOR_HEIGHT
};

} // namespace Gtk


#ifndef DOXYGEN_SHOULD_SKIP_THIS
namespace Glib
{

template <>
class Value<Gtk::SizeRequestMode> : public Glib::Value_Enum<Gtk::SizeRequestMode>
{
public:
  static GType value_type() G_GNUC_CONST;
};

} // namespace Glib
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gtk
{


/** TODO.
 *
 * @newin{3,0}
 */

class SizeRequest : public Glib::Interface
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef SizeRequest CppObjectType;
  typedef SizeRequest_Class CppClassType;
  typedef GtkSizeRequest BaseObjectType;
  typedef GtkSizeRequestIface BaseClassType;

private:
  friend class SizeRequest_Class;
  static CppClassType sizerequest_class_;

  // noncopyable
  SizeRequest(const SizeRequest&);
  SizeRequest& operator=(const SizeRequest&);

protected:
  SizeRequest(); // you must derive from this class

  /** Called by constructors of derived classes. Provide the result of 
   * the Class init() function to ensure that it is properly 
   * initialized.
   * 
   * @param interface_class The Class object for the derived type.
   */
  explicit SizeRequest(const Glib::Interface_Class& interface_class);

public:
  // This is public so that C++ wrapper instances can be
  // created for C instances of unwrapped types.
  // For instance, if an unexpected C type implements the C interface. 
  explicit SizeRequest(GtkSizeRequest* castitem);

protected:
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~SizeRequest();

  static void add_interface(GType gtype_implementer);

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  GtkSizeRequest*       gobj()       { return reinterpret_cast<GtkSizeRequest*>(gobject_); }

  ///Provides access to the underlying C GObject.  
  const GtkSizeRequest* gobj() const { return reinterpret_cast<GtkSizeRequest*>(gobject_); }

private:


  //TODO: vfuncs

public:
  
  /** Gets whether the widget prefers a height-for-width layout
   * or a width-for-height layout.
   * 
   * <note><para>Gtk::Bin widgets generally propagate the preference of
   * their child, container widgets need to request something either in
   * context of their children or in context of their allocation
   * capabilities.</para></note>
   * 
   * @newin{3,0}
   * @return The Gtk::SizeRequestMode preferred by @a widget.
   */
  SizeRequestMode get_request_mode() const;
  
  /** Retrieves a widget's initial minimum and natural width.
   * 
   * <note><para>This call is specific to height-for-width
   * requests.</para></note>
   * 
   * @newin{3,0}
   * @param minimum_width Location to store the minimum width, or <tt>0</tt>.
   * @param natural_width Location to store the natural width, or <tt>0</tt>.
   */
  void get_width(int& minimum_width, int& natural_width) const;
  
  /** Retrieves a widget's minimum and natural height if it would be given
   * the specified @a width.
   * 
   * @newin{3,0}
   * @param width The width which is available for allocation.
   * @param minimum_height Location for storing the minimum height, or <tt>0</tt>.
   * @param natural_height Location for storing the natural height, or <tt>0</tt>.
   */
  void get_height_for_width(int width, int& minimum_height, int& natural_height) const;
  
  /** Retrieves a widget's initial minimum and natural height.
   * 
   * <note><para>This call is specific to width-for-height requests.</para></note>
   * 
   * @newin{3,0}
   * @param minimum_height Location to store the minimum height, or <tt>0</tt>.
   * @param natural_height Location to store the natural height, or <tt>0</tt>.
   */
  void get_height( int& minimum_height, int& natural_height) const;
  
  /** Retrieves a widget's minimum and natural width if it would be given
   * the specified @a height.
   * 
   * @newin{3,0}
   * @param height The height which is available for allocation.
   * @param minimum_width Location for storing the minimum width, or <tt>0</tt>.
   * @param natural_width Location for storing the natural width, or <tt>0</tt>.
   */
  void get_width_for_height(int height, int& minimum_width, int& natural_width) const;
  
  /** Retrieves the minimum and natural size of a widget taking
   * into account the widget's preference for height-for-width management.
   * 
   * This is used to retrieve a suitable size by container widgets which do
   * not impose any restrictions on the child placement.
   * 
   * @newin{3,0}
   * @param minimum_size Location for storing the minimum size, or <tt>0</tt>.
   * @param natural_size Location for storing the natural size, or <tt>0</tt>.
   */
  void get_size(Requisition& minimum_size, Requisition& natural_size);

  //There are no signals or properties.


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


};

} // namespace Gtk


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Gtk::SizeRequest
   */
  Glib::RefPtr<Gtk::SizeRequest> wrap(GtkSizeRequest* object, bool take_copy = false);

} // namespace Glib


#endif /* _GTKMM_SIZEREQUEST_H */

